//  "" -    
Unit Help;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, Buttons, Config,ImgList, ToolWin,
  ShellApi, Menus, mmsystem;

type
  THelpForm = class(TForm)
    procedure CreateObjects; // ,     ,     
    procedure HelpFormActivate(Sender: TObject);
    procedure HelpFormClose(Sender: TObject; var ACtiont : TCloseAction);
    procedure HelpFormKeyDown(Sender: TObject; var Key : Word; Shift : TShiftState);
    procedure ConnectEvents; // ,     
    procedure SetHelp( HelpContext : string ); // ,      HelpConTeex    
    procedure SpRichEditor1KeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);
    procedure GetFilter; // ,        ,   
    procedure ToolButton1Click(Sender: Tobject);
    procedure SizeDownClick(Sender: TObject);
    procedure BackClick(Sender: TObject);
    procedure furtherClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FullCollapseClick(Sender: TObject);
    procedure FullExpendClick(Sender: TObject);
    procedure SpRichEditor1MouseDown(Sender: TObject; Button: TMouseButton;
    Shift: TShiftState; X, Y: Integer);
    procedure SpRichEditor1KeyPress(Sender: TObject; var Key: Char);
    procedure SpTreeView1Click(Sender: TObject);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure Edit2Keydown(Sender: TObject; var Key : word;
    Shift: TShiftState);
    procedure ListBox2KeyPress(Sender: TObject; var Key: Char);
    procedure ListBox2Click(Sender: TObject);
    procedure ExitClick(SEnder: TObject);
    procedure ShowHelpHint(Sender: TObject);
    procedure SpTreeView1KeyDown(Sender: TObject; var Key : Word; Shift : TShiftState);
    procedure HelpMessagesClick(Sender: TObject);
    procedure MinimumClick(SEnder: TObject);
    procedure MediumClick(Sender: TObject);
    procedure MaximumClick(Sender: TObject);
    procedure RabbitIIClick(Sender: TObject);
    procedure BookLIbraryShow(Sender: TObject);
    procedure pure;
    procedure TranseTabSheet1(Sender: TObject);
    procedure TranseTabSheet2(Sender: TObject);
    procedure ListBox2KeyDown(Sender: TObject; var Key : Word; Shift: TShiftState);
    procedure FontDialog1Show(Sender: TObject);
    procedure FontDialog1Close(Sender: Tobject);
    procedure RichEditor1FontDialog(Sender: TObject);
    procedure SpTreeView1FontDialog(Sender: TObject);
    procedure SpeechStoping(Sender: TObject);
    procedure Speaking(s: String);
  private
    function CreateMenuItem(var Item : TMenuItem; Caption, Hint: String): TMenuItem; overload;
    function CreateMenuItem(var Item : TMenuItem; Caption, Hint, ShortCut: String;
    OnClick: TNotifyEvent): TMenuItem; overload;
  public
    SizeUp, SizeDown, Back,   Further, FullCollapse,
    FullExpend, SpeechStoped : TToolButton;
    Image1 : TImage;
    Rect : TRect;
    SpRichEditor1 : TRichEdit;
    Splitter1 : TSplitter;
    PageControl2 : TPageControl;
    tabsheet1, TabSheet2: TTabSheet;
    Edit2 : TEdit;
    ListBox2 : TListBox;
    SpTreeView1 : TTreeView;
    StatusBar1 : TStatusBar;
      StatusPanel1 : TStatusPanel;
    ToolBar2 : TToolBar;
    MainMenu : TMainMenu;
    Files,
     Exit,
    View,
     FontSize, Minimum, Maximum, Medium,
    Servise,
     Expended, Collapsed,
    transition,
     RabbitII, BookLibrary, Back1, Further1, TabSheet1t, TabSheet2t,
    Help, HelpMessages : TMenuItem;
    PopUpMenu1: TPopUpMenu;
     Collapse, Expend, Font: TMenuItem;
    PopUpMenu2 : TPopUpMenu;
     Find, Font1: TMenuItem;
    ImageList1: TImageList;
    FontDialog1 : TFontDialog;
  end;

  THyper = record     // ,         
   x, l, y : integer; // ,  ,  ,   
   FileName : String; //  
  end;

var
  HelpForm: THelpForm; //  
  Hyper : array[1..100] of THyper; // ,   
                                   //    THyper
  P : byte; //  ,   
  HelpContext : String; //  ,    
  Names : array[1..655634] of string; //   .   ""   
  DoItOne : Boolean = true; // ,        
  Count : Integer; //  ,     Names
  Recount : Integer; //   ,    Count,
                     //     .  ,      
  SpeakVisa: Boolean = false; // ,   ,    
  B : Boolean = true; // ,     ,    
  SpeechStop: Boolean = false;
  Message : TWMKeydown;
  KeyName : array[0..20] of char;
// , , ,        
procedure GetHelp( HelpContext : string ); //   ,          

implementation
{$R *.dfm}
uses
 Main, BookLibrary; //  

procedure GetHelp( HelpContext : string );
begin
 With Helpform do
 begin
  Position := poScreenCenter; //    (  ,   )
  Width := 500; //  
  Height := 450; //   
  Constraints.MinWidth := 350; //  
  Constraints.MinHeight := 350; //  
  CreateObjects;  //  
  ConnectEvents; //  
  Show; //  
  SetHelp('Main'); //      
  SpRicheditor1.SelStart := 0; //         
  Spricheditor1.Cursor := crHandPoint;
  SpTreeView1.SetFocus; //   ()  
  SpTreeView1.Cursor := crHandPoint;
  if SpeechStop = false then MainForm.Speech1.Speak('        Main'); //    
 end;
end;
//  
procedure THelpForm.CreateObjects;
var
  ICounter1 : Integer;
  i, o, p : Integer;
  s : String;
    //  
    //    ToolBar
    procedure CreateToolButton(ToolButton: TToolButton; ImageIndex: Integer;
    Click : TNotifyEvent; Visible: Boolean; Hint : String);
    begin;
    Toolbutton := TToolButton.Create(SElf);
    ToolButton.Parent := ToolBar2;
    ToolButton.ImageIndex := ImageIndex;
    ToolButton.OnClick := Click;
    ToolButton.Hint := Hint;
    if Visible = false then ToolButton.Visible := false;
    end;
    //    ImageList
    procedure LoadPicture(FileName: String);
    begin;
    if FileExists(StartDir + '\Resourse\' + FileName + '.bmp') then
    begin
    Image1.Picture.LoadFromFile(StartDir + '\Resourse\' + FileName + '.bmp');
    ImageList1.Add(Image1.Picture.Bitmap, Image1.Picture.Bitmap);
    end
    end;
begin;
  ImageList1 := TImageList.Create(Self); //  ImageList1,      . RC3
  ImageList1.Width  := 18; //  
  ImageList1.Height := 18; //  ,   , 
  Image1 := TImage.Create(SElf); //  Image1
   LoadPicture('6');  // 0    ImageList1.   ,  
   LoadPicture('13'); // 1
   LoadPicture('16'); // 2
   LoadPicture('17'); // 3
   LoadPicture('18'); // 4
   LoadPicture('19'); // 5
   LoadPicture('20'); // 6
   LoadPicture('21'); // 7
   LoadPicture('12'); // 8
  Image1.Destroy;

  if DoItOne then //   , ...
  begin;
  //   
  MainMenu := TMainMenu.Create(Self); //   
   CreateMenuItem(Files, '', '   ');
   MainMenu.Items.Add(Files);
    Files.Add(CreateMenuItem(Exit, '', '  ', 'Esc', ExitClick));
//   CreateMenuItem(View, '', '   ');
//   MainMenu.Items.Add(View);
//    View.Add(CreateMenuItem(Fontsize, ' ', '  . '));
//   FontSize.Add(CreateMenuitem(Minimum,  ' ', '  ', '', MinimumClick));
//    FontSize.Add(CreateMenuItem(Medium, ' ', '  ', '', MediumClick));
//    FontSize.Add( CreateMenuItem(maximum, ' ', '  ', '', MaximumClick));
//   CreateMenuItem(Servise, '', '  ');
//   MainMenu.Items.Add(Servise);
//    Servise.Add(CreateMenuItem(Expended, ' ', '   ', '', FullExpendClick));
//    Servise.Add(CreateMenuItem(Collapsed, ' ', '  ', '', FullCollapseClick));
   CreateMenuItem(transition, '', '   ');
   MainMenu.Items.Add(transition);
    Transition.Add(CreateMenuItem(Back1, '', '    ', 'Alt+2', BackClick));
    Back1.Enabled := false;
    Transition.Add(CreateMenuItem(Further1, '', '      ', 'Alt+1', FurtherClick));
    Further1.Enabled := false;
    transition.Add(CreateMenuItem(RabbitII, 'RabbitII', '    ', 'Ctrl+R', RabbitIIClick));
    transition.Add(CreateMenuItem(BookLibrary, '', '   ', 'Ctrl+L', BookLIbraryShow));
    Transition.Add(CreateMenuItem(TabSheet1t, '  ', '   ', 'F2', TranseTabSheet1));
    Transition.Add(CreateMenuiTem(TabSheet2t, '  ', '   ', 'F3', TranseTabSheet2));
   CreateMenuItem(Help, '', '  ');
   MainMenu.Items.Add(Help);
    Help.Add(CreateMenuItem(HelpMessages, ' ', '   ', 'F1', HelpMessagesClick));
  //     
  PopUpMenu1 := TPopUpMenu.Create(SElf); //   
  PopUpMenu1.Items.Add(CreateMenuItem(Collapse, ' ', '     ', '', fullCollapseClick));
  PopUpMenu1.Items.Add(CreateMenuItem(Expend, ' ', '   ', '', FullExpendClick));
  PopUpMenu1.Items.Add(CreateMenuItem(Font, ' ', ' ', '', SpTreeView1FontDialog));
  //     
  PopUpMenu2 := TPopUpMenu.Create(Self);
  PopUpMenu2.Items.Add(CreateMenuItem(Find, '', '', 'Ctrl+F', Exitclick));
  PopUpMenu2.Items.Add(CreateMenuItem(Font, '', ' ', '', RichEditor1FontDialog));
  //       
  FontDialog1 := TFontDialog.Create(Self); //   
  FontDialog1.Font.Size := 14; //   
  FontDialog1.Font.Name := 'Times New Romen Cyr'; //  
  FontDialog1.MinFontSize := 9; //   
  FontDialog1.MaxFontSize := 30; //   
  FontDialog1.OnShow := FontDialog1Show; // ,      
  FontDialog1.OnClose := FontDialog1Close; // ,      
  //  PageControl2   
  PageControl2 := TPageControl.Create(Self);
  With PageControl2 do
  begin
    Align := alLeft;     //  
    Parent := HelpForm;  //   
    ActivePage := tabsheet1; //   
    Width := 140;        //  
    Constraints.MaxWidth := 220; //   
    Constraints.MinWidth := 50;  //   
                                 //   ,    
                                 //  PageControl2     
  end;
  //     pageControl2   
  tabsheet1 := TTabSheet.Create(Self); //    PageControl2
  TabSheet1.TabOrder := 2;
  tabsheet1.Caption := ''; //  
  tabsheet1.PageControl := PageControl2; //  
  tabsheet1.PageIndex := 0; //   
    //   
  SpTreeView1 := TTreeView.Create(SElf); // 
  With SpTreeView1 do
  begin
   Parent := TabSheet1;  //   
   TabOrder := 0;
   Hint := ' ';
  if FileExists(StartDir + '\Help\HelpTree.txt' ) then //       
   LoadFromFile(StartDir + '\Help\HelpTree.txt'); //  
   ShowButtons := false; // ,   
   ShowLines := false;   //  ,      
   Images := ImageList1; // ,   
   Align := AlClient;    //      PageControl2
   PopUpMenu := PopUpMenu1;
   Fullexpand;
  end;
  //     
  for iCounter1 := 0 to SpTreeView1.Items.Count-1 do
  begin
    if (SpTreeView1.Items[ICounter1].HasChildren) then //     
    SpTreeView1.Items[ICounter1].ImageIndex := 0       //    ,
    else SpTreeView1.Items[ICounter1].ImageIndex := 6; //   - 
  end;
  SpTreeView1.HideSelection := false; //     
  SpTreeView1.Selected := SpTreeView1.Items[0]; //   
//  SpTreeView1.Items[0].ImageIndex := 0;
  //     pageControl2   
  TabSheet2:= TTabSheet.Create(Self); //    PageControl2
  TabSheet2.TabOrder := 3;
  TabSheet2.Caption := ''; //  
  TabSheet2.PageControl := PageControl2; //  
  TabSheet2.PageIndex := 1; //   
  //   
  Edit2 := TEdit.Create(Self);
  Edit2.Parent := TabSheet2; //     PageControl2
  Edit2.Align := alTop; //  
  Edit2.Hint := '   ';
  //  ,       
  ListBox2 := TListBox.Create(Self);
  With LIstBox2 do
  begin
    Parent := TabSheet2; //     PageControl2
    Align := AlClient;   //       PageControl2,
                         //    
    Top := Edit2.Height + 2; //        
    Left := tabsheet1.Left; //    ,   
    Height := TabSheet2.Height; // 
    Items.LoadFromFile(StartDir + '\help\HelpTree.txt'); //  
    Selected[0] := true; //   
    Hint := ' ';
  end;
  Edit2.Text := ListBox2.Items[LIstBox2.ItemIndex]; //    
//     ,      
for o := 1 to LIstBox2.Items.Count - 1 do
begin
for p := 1 to 10 do
begin
for i := 1 to Length(ListBox2.Items[o])-1 do
begin
 if ListBox2.Items[o][i] = #9 then
 begin
  s := ListBox2.Items[o];
  Delete(s, i, 1);
  ListBox2.Items[o] :=s;
 end
 else Break;
end;
end;
end;
  Splitter1 := TSplitter.Create(Self);
  With Splitter1 do
  begin
   Align := alLeft; //  
   Parent := HelpForm; //   
   Width := 2; //  - 10 
   Left := 110; //      
  end;
  SpRicheditor1 := TRichedit.Create(Self); //   a RichEdit
  With SpRicheditor1 do //  Richedit
  begin
   TabOrder := 1;
   Align := alClient; //    
   Parent := HelpForm;              //    
   ReadOnly := true;                //    
   HideScrollBars := false;         //   
   ScrollBars :=ssBoth;             //   
   Font.Size := 12;                 //   - 12
   Font.Name := 'Times New Roman';  //  
   Hint := ' ';   //  
   PopUpmenu := PopUpMenu2;
  end;
   //    ToolBar2
   ToolBar2 := TToolBar.Create(SElf); //   
   ToolBar2.Parent := HelpForm; //   
   ToolBar2.Images := ImageList1; //  ,    
   //    
   CreateToolButton(SpeechStoped, 7, SpeechStoping, false, ' ');
   CreateToolButton(FullCollapse,2, FullCollapseClick, False, '   ');
   CreateToolButton(FullExpend, 3, FullExpendClick, false, '   ');
   CreateToolButton(SizeUp, 8, ToolButton1Click, false, '  ');
   CreateToolButton(SizeDown, 1, SizeDownClick, false, '  ');
   //       ""
   further := TToolButton.Create(Self);
   further.Parent := ToolBar2;
   further.ImageIndex := 5;
   further.OnClick := furtherClick;
   further.Enabled := false;
   //       ""
   Back := TToolButton.Create(Self);
   Back.Parent := ToolBar2;
   Back.ImageIndex := 4;
   Back.OnClick := BackClick;
   Back.Enabled := false;
   //      
   StatusBar1 := TStatusBar.Create(Self); //    ( )
   StatusBar1.Parent := HelpForm;
   StatusBar1.Panels.AddItem(StatusPanel1, 0);
   StatusBar1.Panels[0].Style := psText;

   Count := 0;
   ReCount := 0;
  DoItOne := false;
  end;
end;

//  
procedure THelpForm.ConnectEvents;
begin;
  HelpForm.OnClose := HelpFormClose;  //   
  HelpForm.OnActivate := HelpFormActivate; //  
  HelpForm.OnKeyDown := HelpFormKeyDown; //     
  Application.OnHint := ShowHelpHint; //       
  With SpRichEditor1 do //     
  begin
   OnKeyPress := SpRicheditor1KeyPress; //    
   OnKeyDown := SpRicheditor1KeyDown; //    
   OnMouseDown := SpRicheditor1MouseDown; //   
  end;
  LIstBox2.OnClick :=  ListBox2Click; //    
  LIstBox2.OnKeyPress := ListBox2KeyPress; //      
  SpTreeView1.OnClick := SpTreeView1Click; //     
  SpTreeView1.OnKeyDown := SpTreeView1KeyDown; //       
  Edit2.OnKeyPress := Edit2KeyPress; //       
  HelpMessages.OnClick := HelpMessagesClick; //      
  Exit.OnClick := ExitClick; // //      
  Edit2.OnKeyDown := Edit2KeyDown; //      
  ListBox2.OnKeyDown := ListBox2KeyDown;
end;
// ,   ,  , 
//    
procedure THelpForm.SetHelp( HelpContext : string );
begin
 if FileExists(StartDir + '\help\' + HelpContext + '.txt') then //        
 begin //   
   SpRichEditor1.Lines.LoadFromFile(StartDir + '\' + 'help\' + HelpContext + '.txt');
   If SpRichEditor1.Text <> '' then //     ,  
   begin;
   With SpRichEditor1 do
   begin
     HideSelection := true; //  
     SElectAll; //  
     Font.Style := []; //   
     Font.Color := clBlack; //    
     SelLength := 0; //  
     SelLength := Length(SpRichEditor1.Lines[0]); //     
     SelAttributes.Size := 14; //       14
     SelAttributes.Style := [fsBold]; //   
     SelLength := 0; //  
   end;
   end;
   GetFilter; //  
   Inc(Count); //          
   Names[Count] := HelpContext; //        
   if count > 1 then //      
                     //        
   begin
   Back.Enabled := true;
   Back1.Enabled:= true;
   end;
  end
  else SpRichEditor1.Text := '   '; //     
end;
//       
//      SpRichEditor1
procedure THelpForm.SpRichEditor1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  i : integer;
begin
//   <Enter>,   ,  -      
case Key of
vk_end :
begin
MessageBeep(mb_Ok);
if SpeechStop = false then
begin
Speaking('  ');
end;
end;
vk_home :
begin
MessageBeep(mb_Ok);
Speaking('  ');
end;
VK_ESCAPE : Close; //   <Rscape>  
//   <Enter>,     ,     
//   
VK_Return :
begin
GetKeyNameText(Message.KeyData, KeyName, 21);
 StatusBar1.Panels[0].Text := KeyName;
 DestroyCaret;
 if SpRichEditor1.Text <> '' then
 begin
  for i := 1 to p - 1 do
   begin
   if (SpRichEditor1.SelStart >= Hyper[i].x - 1 ) and
      (SpRichEditor1.SelStart <= Hyper[i].x - 1 + Hyper[i].l) then
    begin
     SetHelp(Hyper[i].FileName);
    end;
   end;
  end;
 end;
vk_f10 : //    
begin
 DestroyCaret; // kill caret
 if SpeechStop = false then
 begin
 Speaking('   ');
 end;
end;
vk_left: //       
 begin
  DestroyCaret; //  
  if SpeechStop = false then
  begin
  Speaking(SpRiChEditor1.Lines[SpRichEditor1.CaretPos.Y][SpRichEditor1.CaretPos.X -1]);
  end;
 end;
vk_Right : //         
 begin
  DestroyCaret; //  
  if SpeechStop = false then
  begin
  Speaking(SpRiChEditor1.Lines[SpRichEditor1.CaretPos.Y][   SpRichEditor1.CaretPos.X]);
  end;
 end;
end;
//         <Alt> +  
if ssalt in shift then
begin
 DestroyCaret; //  
 if Key = vk_down then
 begin
  for i := 1 to p - 1 do
  begin
   if (SpRichEditor1.SelStart < Hyper[i].x - 1) then
    begin
     SpRichEditor1.SelStart := Hyper[i].x - 1;
     SpRichEditor1.SelLength := Hyper[i].l;
     if SpeechStop = false then
     begin
     Speaking(Hyper[i].FileName);
     end;
     Break;
    end;
   end;
  end
  else if Key = vk_Up then //         <Alt> +  
  begin
  DestroyCaret;
    for i := p -1  downto 1 do
    begin
     if (SpRichEditor1.SelStart > Hyper[i].x - 1)
     then
     begin
      spRichEditor1.SelStart := Hyper[i].x - 1;
      SpRichEditor1.SelLength := Hyper[i].l;
      if SpeechStop = false then
      begin
      Speaking(Hyper[i].FileName);
      end;
      Break;
      end;
    end;
  end;
end;
if ssCtrl in Shift then
begin;
 DestroyCaret;
 if (Key = vk_End) or (Key = vk_home) then SpeaKing(SpRichEditor1.Lines[SpRicheditor1.CaretPos.Y]);
 //    Control  End  Home,   ,      
end;
end;
// ,  ,          Hyper
procedure THelpForm.GetFilter;
var
  TextLength, r, i, j, o1, o2, g : Integer;
  s : string;
begin;
  TextLength := 0;//  
  p := 1; //  
  for r := 0 to SpRichEditor1.Lines.Count - 1 do //     
                                                 //    
  begin;
    s := SpRichEditor1.Lines[r]; //   s    
                                 //  r
    i := 0; // ,       s
  if s <> '' then //    
  begin
  repeat //      s
    inc(i); //  i    1
    if s[i] = '@' then //   S   i  @, 
    begin;
    o1 := 0; //  ,     
    o2 := 0; //  ,     
    j := i;  //   ,     i   
             //     (  )
      repeat
        inc(j); //    j  1
        if ((s[j] = ' ') or (j = Length(s))) and (o1 = 0) then o1 := j + 1 //   
        //    j       
        //        0  o1 := j + 1
        else
        if ((s[j] = ' ') or (j = Length(s)))and (o1 <> 0) then o2 := j; //   
        //   j       
        //        0  o2 := j
      until (o2 <> 0) or (j = Length(s)); //       
                                          //     s
      Hyper[p].FileName := ''; //   
      //    ,      
      for g := i + 1 to o1 - 2 do Hyper[p].FileName := Hyper[p].FileName + s[g];
      for g := i to Length(s) - (o1 - i) do
       s[g] := s[g + (o1 - i)];
       SetLength(s, Length(s) - (o1 - i));
       Hyper[p].x := i + TextLength;
       Hyper[p].l := o2 - o1;
       hyper[p].y := r;
       inc(p);
    end;
  until i >= Length(s);
  end;
    SpRichEditor1.Lines[r] := s; //  s    
    inc(TextLength, Length(s) + 2); //       
  end;
  With SpRichEditor1 do //   
  begin;
   for i := 1 to p - 1 do
   begin
   if Hyper[i].l <> 0 then begin
   SelStart := Hyper[i].x - 1; //     
   SelLength := Hyper[i].l + 1; //  
   Hyper[i].y := i;
   SelAttributes.Color := clBlue; //   
   SelAttributes.Style := [fsunderline]; // 
   SelLength := 0; //   
   SElStart := 0; //     
   SElText := ''; //  
   end;
   end;
end;

end;
//         
procedure THelpForm.ToolButton1Click(Sender: TObject);
begin;
With SpRicheditor1 do
begin;
  if SelAttributes.Size < 20 then
  begin
  SelStart := 0;
  SelectAll;
  SelAttributes.Size := SpRichEditor1.SelAttributes.Size + 1;
  SelLength := Length(SpRichEditor1.Lines[0]);
  SelAttributes.Size := SpRichEditor1.SelAttributes.Size + 2;
  SelAttributes.Style := [fsBold];
  HideSelection := true;
  SelLength := 0;
  SelStart := 0;
  end;
end;
if SpTreeView1.Font.Size < 18 then SpTreeView1.Font.Size := SpTreeView1.Font.Size + 1;
SpTreeView1.Refresh;
if Edit2.Font.Size < 18 then  Edit2.Font.Size := Edit2.Font.Size + 1;
edit2.Refresh;
if ListBox2.Font.Size < 18 then ListBox2.Font.Size := ListBox2.Font.Size + 1;
ListBox2.Refresh;
end;
//         
procedure THelpForm.SizeDownClick(SEnder: TOBject);
begin;
With SpRicheditor1 do
begin;
  if SelAttributes.Size > 9 then
  begin
  SelStart := 0;
  SelectAll;
  SelAttributes.Size := SpRichEditor1.SelAttributes.Size - 1;
  SelLength := Length(SpRichEditor1.Lines[0]);
  SelAttributes.Size := SpRichEditor1.SelAttributes.Size - 2;
  SelAttributes.Style := [fsBold];
  HideSelection := true;
  end;
end;
SpRichEditor1.SelStart := 0;
if SpTreeView1.Font.Size > 9 then SpTreeView1.Font.Size := SpTreeView1.Font.Size - 1;
SpTreeView1.Refresh;
if Edit2.Font.Size > 9 then  Edit2.Font.Size := Edit2.Font.Size - 1;
edit2.Refresh;
if ListBox2.Font.Size > 9 then ListBox2.Font.Size := ListBox2.Font.Size - 1;
ListBox2.Refresh;
end;
//           
procedure THelpForm.BackClick(Sender: TObject);
begin;
if Count = 1 then
Begin
Back.Enabled := false;
Back1.Enabled := false;
end
else
begin
  Dec(Count);
  Inc(ReCount);
  if fileexists(StartDir + '\help\' + Names[Count] + '.txt') then
  SpRichEditor1.Lines.LoadFromFile(StartDir + '\help\' + Names[Count] + '.txt');
  GetFilter;
     If SpRichEditor1.Text <> '' then
   begin;
   With SpRichEditor1 do
   begin
     HideSelection := true;
     SElectAll;
     Font.Style := [];
     Font.Color := clBlack;
     SelLength := 0;
     SelLength := Length(SpRichEditor1.Lines[0]);
     SelAttributes.Size := 14;
     SelAttributes.Style := [fsBold];
     SelLength := 0;
   end;
   end;
   Further.Enabled := true;
   Further1.Enabled := true;
   end;
end;
//     Escape
procedure THelpForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #27 then Close;
end;
//  
procedure THelpForm.FullCollapseClick(Sender: TObject);
begin;
  SpTreeView1.FullCollapse;
end;
//         
//   
procedure THelpForm.FullExpendClick(Sender: TObject);
begin;
  SpTreeView1.FullExpand;
end;
//        , (  )   
procedure THelpForm.furtherClick(Sender: TObject);
begin;
  Inc(Count);
  Dec(ReCount);
  if ReCount <= 1 then Further.Enabled := false;
  if fileexists(StartDir + '\help\' + Names[Count] + '.txt') then
  SpRichEditor1.Lines.LoadFromFile(StartDir + '\help\' + Names[Count] + '.txt');
  Getfilter;
   If SpRichEditor1.Text <> '' then
   begin;
   With SpRichEditor1 do
   begin
     HideSelection := true;
     SElectAll;
     Font.Style := [];
     Font.Color := clBlack;
     SelLength := 0;
     SelLength := Length(SpRichEditor1.Lines[0]);
     SelAttributes.Size := 14;
     SelAttributes.Style := [fsBold];
     SelLength := 0;
   end;
   end;
  if Count > 1 then Back.Enabled := true;
  IF nAMES[cOUNT]  = Names[Count - 1] then Further.Enabled := false;
end;
//       ,     , 
//  
procedure THelpForm.SpRichEditor1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  i : integer;
begin
    DestroyCaret;
    if SpRichEditor1.Text <> '' then
    begin
    for i := 1 to p - 1 do
    begin
    if (SpRichEditor1.SelStart > Hyper[i].x - 1 ) and
       (SpRichEditor1.SelStart < Hyper[i].x - 1 + Hyper[i].l) then
       begin
         SetHelp(Hyper[i].FileName);
       end;
    end;
    end;
end;
//      Escape
procedure THelpForm.SpRichEditor1KeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #27 then
  begin
  close; //   
  DestroyCaret; // kill caret
  end;
end;
//      
procedure THelpForm.SpTreeView1Click(Sender: TObject);
begin
if SpTreeView1.Selected.HasChildren then
begin
SpTreeView1.Selected.ImageIndex := 0;
SpTreeView1.Selected.SelectedIndex := 6;
end;
if SpTreeView1.Selected.HasChildren = false then
begin
SpTreeView1.Selected.ImageIndex := 6;
SpTreeView1.Selected.SelectedIndex := 0;
end;
 if FileExists(StartDir + '\' + 'help\' +   SpTreeView1.Selected.Text  + '.txt') then
  begin
    SpRichEditor1.Clear;
    SetHelp(SpTreeView1.Selected.Text);
  end
  else
  SpRichEditor1.Text := '   ';
  if SpeechStop = false
  then
  begin
  Speaking(SpTreeView1.Selected.Text);
  end;
end;
//       
procedure THelpForm.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
  if key = #27 then Close;  //   Escape - 
  if Key = #13 Then SetHelp(Edit2.text); //   Enter -   
end;
//      
procedure THelpForm.ListBox2KeyPress(Sender: TObject; var Key: Char);
begin
  if key = #27 then Close; //   Escape - 
  if Key = #13 then SetHelp(Edit2.Text); //   Enter -   
end;
//     
procedure THelpForm.ListBox2Click(Sender: TObject);
begin
  Edit2.Text := ListBox2.Items[ListBox2.itemIndex];
  SetHelp(Edit2.Text); //   
end;
//     ""
procedure THelpForm.ExitClick(Sender: TObject);
begin
  Close;
end;

procedure THelpForm.HelpFormClose(Sender: TObject; var ACtiont : TCloseAction);
Begin;
  Application.OnHint := MainForm.ShowHint; //  ,    
  if (SpeechStop = false) and (Application.Hint <> '') then
  begin
  Speaking(Application.Hint);
  end;
  Sleep(1000);
end;
//   
//   ,          
//  
procedure THelpForm.ShowHelpHint(Sender: TObject);
begin;
  StatusBar1.Panels[0].Text := Application.Hint;
if SpeechStop = false then
begin
  Speaking(Application.Hint);
end;
end;
///    
procedure THelpForm.HelpFormActivate(Sender: TObject);
begin;
if b = true then //    
begin
if SpeechStop = false then
begin
 Speaking('        '); //    
end;
b := false;
end
else
begin
if SpeechStop = false then
begin
 Speaking('   ') //  ,  
end;
end;
end;
//       
procedure THelpForm.SpTreeView1KeyDown(Sender: TObject; var Key : Word; Shift : TShiftState);
begin;
if Key = vk_f10 then //    F10
begin
if SpeechStop = false then
begin
 Speaking('   ');
end;
end;
if Key = vk_return then //    Enter
begin
if SpTreeView1.Selected.HasChildren then SpTreeView1.Selected.Expanded := true;
if SpeechStop = false then
begin
 Speaking(SpRichEditor1.Text);
end;
//        ,  
end;
if Key = vk_escape then Close; //    Escape -   
if Key = vk_end then //        
begin //      
MessageBeep(mb_Ok);
If SpeechStop = false then
begin
 Speaking('  ');
end;
end;
if Key = vk_home then //  ,      
begin
MessageBeep(mb_Ok);
If SpeechStop = false then
begin
 Speaking('  ');
end;
end;
if Key = VK_DOWN then
try
 SetHelp(SpTreeView1.Selected.GetNext.Text); //        
 StatusBar1.Panels[0].Text := SpTreeView1.Selected.GetNext.Text;
 Speaking(SpTreeView1.Selected.GetNext.Text)
except
begin
MessageBeep(mb_Ok);
Speaking('    ');
end;
end;
if Key = VK_up then
try
begin
SetHelp(SpTreeView1.Selected.GetPrev.Text);
StatusBar1.Panels[0].Text := SpTreeView1.Selected.GetPrev.Text;
Speaking(SpTreeView1.Selected.GetPrev.Text);
end;
except
begin
MessageBeep(mb_Ok);
Speaking('    ');
end;
end;
end;
//      
procedure THelpForm.HelpFormKeyDown(Sender: TObject; var Key : Word;
Shift: TShiftState);
begin;
if Key = vk_f10 then
begin
if SpeechStop = false then
begin
 Speaking('   ');
end;
end;
if (Key = vk_up) or(Key = vk_down) then SpTreeView1.SetFocus;
if Key = vk_f10 then
begin
if SpeechStop = false then
begin
 Speaking('   ');
end;
end;
end;
// ,     
function THelpForm.CreateMenuItem(var Item: TMenuItem; Caption, Hint: String): TMenuItem;
begin
Item := TMenuitem.Create(Self); //   
Item.Caption := Caption; //  
Item.Hint := HInt;
CreateMenuItem := Item; //   
end;
//     
function THelpForm.CreateMenuItem(var Item : TMenuItem; Caption, Hint, ShortCut: String;
    OnClick: TNotifyEvent): TMenuItem;
begin;
Item := TMenuitem.Create(Self); //   
Item.Caption := Caption; //  
Item.OnClick := OnClick; //         
Item.Hint := Hint; // 
Item.ShortCut := TextToShortCut(ShortCut); // " "
CreateMenuItem := Item; //   
end;
//     
procedure THelpForm.HelpMessagesClick(Sender: TObject);
begin
 SetHelp('  ');
end;
//     
procedure THelpForm.MinimumClick(Sender: TObject);
begin;
SpTreeView1.Font.Size :=  9;
Edit2.Font.Size := 9;
ListBox2.Font.Size := 9;
With SpRicheditor1 do
begin;
  SelStart := 0;
  SelectAll;
  SelAttributes.Size :=  9;
  SelLength := Length(SpRichEditor1.Lines[0]);
  SelAttributes.Size := 10;
  SelAttributes.Style := [fsBold];
  HideSelection := true;
end;
SpRichEditor1.SelStart := 0;
end;
//     
procedure THelpForm.MediumClick(Sender: TObject);
begin;
SpTreeView1.Font.Size :=  13;
Edit2.Font.Size := 13;
ListBox2.Font.Size := 13;
With SpRicheditor1 do
begin
  SelStart := 0;
  SelectAll;
  SelAttributes.Size := 13;
  SelLength := Length(SpRichEditor1.Lines[0]);
  SelAttributes.Size := 14;
  SelAttributes.Style := [fsBold];
  HideSelection := true;
end;
SpRichEditor1.SelStart := 0;
end;
//     
procedure THelpForm.MaximumClick(SEnder: TObject);
begin;
SpTreeView1.Font.Size :=  17;
Edit2.Font.Size := 17;
ListBox2.Font.Size := 17;
SpRichEditor1.Font.Size := 17;
With SpRicheditor1 do
begin;
  if SelAttributes.Size > 9 then
  begin
  SelStart := 0;
  SelectAll;
  SelAttributes.Size := 16;
  SelLength := Length(SpRichEditor1.Lines[0]);
  SelAttributes.Size := 17;
  SelAttributes.Style := [fsBold];
  HideSelection := true;
  end;
end;
SpRichEditor1.SelStart := 0;
end;
//     
procedure THelpForm.RabbitIIClick(Sender: TObject);
begin;
  MainForm.Show;
  Close;
end;
//     
procedure THelpForm.BookLIbraryShow(SEnder: TObject);
begin;
MainForm.LibraryShow(Sender);
Close;
end;

procedure THelpForm.pure;
begin;
end;
//      
procedure THelpForm.Edit2Keydown(SEnder: TObject; var Key: Word;
Shift: TShiftState);
begin; //       
if (Key = vk_down) or (Key = vk_up) then LIstBox2.SetFocus; //   
end;
// ,     PageControl2
procedure THelpForm.TranseTabSheet1(Sender: TObject);
begin;
 TabSheet1.Visible := true; //    
 TabSheet2.Visible := false; //    
 PageControl2.ActivePage := TabSheet1; //   , 
                                       //  PageControl2   
 TabSheet1.PageIndex := 1; //    
 TabSheet2.PageIndex := 0;
 SpTreeView1.SetFocus; //    
 if SpeechStop = false then
 begin
 Speaking('    '); //     
 end;
end;
// ,     PageControl2
procedure THelpForm.TranseTabSheet2(Sender: TObject);
begin
 TabSheet1.Visible := false; //    
 TabSheet2.Visible := true; //    
 PageControl2.ActivePage := TabSheet1; //   , 
                                       //  PageControl2   
 TabSheet1.PageIndex := 0; //    
 TabSheet2.PageIndex := 1;
 Edit2.SetFocus; //      
 if SpeechStop = false then
 begin
  Speaking('      '); //     
 end;
end;
//      
procedure THelpForm.ListBox2KeyDown(Sender: TObject; var Key : Word; Shift: TShiftState);
begin;
if (Key = vk_down) or (Key = vk_Up) then //     
begin;
if SpeechStop = false then
begin
 Speaking( ListBox2.Items[ListBox2.ItemIndex + 1]);
end;
end;
end;

procedure THelpForm.SpTreeView1FontDialog(Sender: TObject);
begin
FontDialog1.Execute;
SpTreeView1.Font.Size := FontDialog1.Font.Size;
SpTreeView1.Font.Style := FontDialog1.Font.Style;
SpTreeView1.Font.Name := FontDialog1.Font.Name;
end;

procedure THelpForm.FontDialog1Show(Sender: TObject);
begin
if SpeechStop = false then
begin
 Speaking('   ');
end;
end;

procedure THelpForm.FontDialog1Close(Sender: TObject);
begin
if SpeechStop = false then
begin
 Speaking('   ');
Sleep(100);
end;
end;

procedure THelpForm.RichEditor1FontDialog(Sender: TObject);
begin
FontDialog1.Execute;
With SpRicheditor1 do
begin;
  SelStart := 0;
  SelectAll;
  SelAttributes.Size := FontDialog1.Font.Size;
  SelLength := Length(SpRichEditor1.Lines[0]);
  SelAttributes.Size := FontDialog1.Font.Size;
  SelAttributes.Style := FontDialog1.Font.Style;
  SelAttributes.Name := FontDialog1.Name;
  HideSelection := true;
end;
SpRichEditor1.SelStart := 0;
refresh;
end;

procedure THelpForm.SpeechStoping(Sender: TObject);
begin;
 if SpeechStop then
 begin
 SpeechStop := false;
 Speaking('  ');
 end
 else
 begin
  Speaking('  ');
  SpeechStop := true;
 end;
end;

procedure THelpForm.Speaking(S: String);
begin;
Mainform.Speech1.Stop;
if S <> '' then
MainForm.Speech1.Speak(S);
end;

end.

// 

