//------------------------------------------------------------------------------
// Project Rabbit II Open Source FreeWare
//
// http://wtwsoft.narod.ru/build.htm
// original download from http://wtwsoft.narod.ru
// mailto: wtwsoft@narod.ru
//     
//------------------------------------------------------------------------------
//        Delphi 7
// TSAPI/TSAPI.BPL,  !compile_component.bat
//------------------------------------------------------------------------------
{$J+}
program Rabbit2;
uses
  Forms,
  Graphics,
  SysUtils,
  Main in 'Main.pas' {MainForm},
  View in 'View.pas' {ViewForm},
  Dictionary in 'Dictionary.pas' {DictionaryForm},
  config in 'Config.pas',
  Help in 'Help.pas',
  BookLibrary in 'BookLibrary.pas' {LibraryForm},
  AddBookDialog in 'AddBookDialog.pas' {AddBookForm},
  NoSAPI in 'NoSAPI.pas' {NoSAPIForm},
  Service in 'Service.pas',
  AddDictionaryDialog in 'AddDictionaryDialog.pas' {AddDictionaryForm},
  SPEECH4 in 'SAPI\SPEECH4.PAS',
  SAPI4 in 'SAPI\sapi4.pas',
  About in 'About.pas' {Form1},
  Word97 in 'Word\Word97.pas',
  Office97 in 'Word\Office97.pas',
  VBide97 in 'Word\VBide97.pas',
  log in 'log.pas' {LogoForm},
  MSWord in 'MSWord.pas';

{$R rabbit2.res} //      
//      ,        
procedure BeforeInit;
var
  LangStr   : string;
  LangCount : byte;
begin
  GetDir( 0, StartDir );  //   ,    , 
                          //  ,     Rabbit.     
                          //    StartDir
   //        ,        .
  AddToLog('Prepare to open config folder ');
  AutoSave  := StrToBool(GetMConf('Autosave'));//  ,    
  //            \config\main.ini
  for LangCount := 1 to 20 do
   begin
    LangStr := GetMConf( 'Lang' + IntToStr( LangCount ));     //      
    if LangStr[1]<>'%' then LangFolder[LangCount] := LangStr; //    ,      
   end;
  CurentLang := StrToInt( GetMConf( 'InterfaceLang' ));       //    ,       ,
  AddToLog('Set language - ' + LangFolder[CurentLang]);
end;
// StartUp:
begin
  AddToLog('+ Starting Rabbit II');
  LogoForm := TLogoForm.Create(nil);
  LogoForm.Label3.Caption := LogoForm.Label3.Caption + ' v'+ RVersion;
  LogoForm.Refresh;
  LogoForm.Show;
  LogoForm.Refresh;
  AddToLog('Prepare to initializate');
  BeforeInit;
  AddToLog('Application initializate');
  Forms.Application.Initialize;
  AddToLog('Forms create');
  Forms.Application.CreateForm(TMainForm, MainForm);
  Forms.Application.CreateForm(THelpForm, HelpForm);
  Forms.Application.CreateForm(TAddBookForm, AddBookForm);
  Forms.Application.CreateForm(TNoSAPIForm, NoSAPIForm);
  Forms.Application.CreateForm(TAboutForm, AboutForm);
  MainForm.BuildMainForm;
  LogoForm.Hide;
  LogoForm.Destroy;
  AddToLog('Run shell');
  Forms.Application.Run;
  AddToLog('+ Shuting down Rabbit II');
end.
